/*
 * Copyright (c) 2016, 2017, 2018, 2019 FabricMC
 * Copyright 2024 The Quilt Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.fabricmc.fabric.api.networking.v1;

import net.minecraft.class_2960;
import net.minecraft.class_8605;
import net.minecraft.class_8610;
import org.quiltmc.qsl.networking.api.ServerConfigurationTaskManager;

/**
 * Fabric-provided extensions for {@link class_8610}.
 * This interface is automatically implemented via Mixin and interface injection.
 *
 * @deprecated See {@link ServerConfigurationTaskManager}
 */
@Deprecated
public interface FabricServerConfigurationNetworkHandler extends ServerConfigurationTaskManager {
	/**
	 * Enqueues a {@link class_8605} task to be processed.
	 *
	 * <p>Before adding a task use {@link ServerConfigurationNetworking#canSend(class_8610, class_2960)}
	 * to ensure that the client can process this task.
	 *
	 * <p>Once the client has handled the task a packet should be sent to the server.
	 * Upon receiving this packet the server should call {@link FabricServerConfigurationNetworkHandler#completeTask(class_8605.class_8606)},
	 * otherwise the client cannot join the world.
	 *
	 * @param task the task
	 */
	default void addTask(class_8605 task) {
		throw new UnsupportedOperationException("Implemented via mixin");
	}

	/**
	 * Completes the task identified by {@code key}.
	 *
	 * @param key the task key
	 * @throws IllegalStateException if the current task is not {@code key}
	 */
	default void completeTask(class_8605.class_8606 key) {
		throw new UnsupportedOperationException("Implemented via mixin");
	}
}
